/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/*!
 * Next Core
 * Copyright(c) 2006-2011 Xenophy.CO.,LTD All rights Reserved.
 * http://www.xenophy.com
 */

// {{{ requires

require('nx-core');
require('should');
assert = require('assert');

// }}}
// {{{ NX.Date.parse Tests

module.exports = {

    // {{{ 'test parse#pattern1'

    'test parse#pattern1': function() {

        var dt = new Date();

        dt = NX.Date.parse("2006", "Y");
        NX.Date.format(dt, 'Y').should.equal('2006');

        dt = NX.Date.parse("2011/01/01", "Y/m/d");
        NX.Date.format(dt, 'Y/m/d').should.equal('2011/01/01');

        dt = NX.Date.parse('00:01:00 m is month', "H:m:s \\m \\i\\s\ \\m\\o\\n\\t\\h");
        NX.Date.format(dt, "H:m:s \\m \\i\\s\ \\m\\o\\n\\t\\h").should.equal('00:01:00 m is month');

        dt = NX.Date.parse("2006-01-15", "Y-m-d");
        NX.Date.format(dt, 'Y-m-d').should.equal('2006-01-15');

        dt = NX.Date.parse("2006-01-15 3:20:01 PM", "Y-m-d g:i:s A");
        NX.Date.format(dt, 'Y-m-d g:i:s A').should.equal('2006-01-15 3:20:01 PM');

        dt = NX.Date.parse("2006-02-29 03:20:01", "Y-m-d H:i:s", true);
        assert.equal(dt, null);

        dt = NX.Date.parse("2006-01-01 Sun", "Y-m-d D");
        NX.Date.format(dt, 'Y-m-d D').should.equal('2006-01-01 Sun');

        dt = NX.Date.parse("2006-01-01 Sunday", "Y-m-d l");
        NX.Date.format(dt, 'Y-m-d l').should.equal('2006-01-01 Sunday');

        dt = NX.Date.parse("2006 January", "Y F");
        NX.Date.format(dt, 'Y F').should.equal('2006 January');

        dt = NX.Date.parse("2006 Jan", "Y M");
        NX.Date.format(dt, 'Y M').should.equal('2006 Jan');

        dt = NX.Date.parse("2006", "o");
        NX.Date.format(dt, 'o').should.equal('2006');

        dt = NX.Date.parse("2006-01-01 12:43:12", "Y-m-d h:i:s");
        NX.Date.format(dt, 'Y-m-d h:i:s').should.equal('2006-01-01 12:43:12');

        dt = NX.Date.parse("2006-01-01 12:43:12 +02:00", "Y-m-d h:i:s P");
        NX.Date.format(dt, 'Y-m-d h:i:s P').should.equal('2006-01-01 07:43:12 +09:00');

        dt = NX.Date.parse("2006-01-01 12:43:12 +0200", "Y-m-d h:i:s O");
        NX.Date.format(dt, 'Y-m-d h:i:s O').should.equal('2006-01-01 07:43:12 +0900');

        dt = NX.Date.parse("2004-02-12T15:19:21+00:00", "c");
        NX.Date.format(dt, 'c').should.equal('2004-02-13T00:19:21+09:00');

    }

    // }}}

};

// }}}

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * c-hanging-comment-ender-p: nil
 * End:
 */
